import { __awaiter, __generator, __assign } from 'tslib';
import { registerPlugin } from '@scullyio/scully';
import { createClient } from 'contentful';

// TODO: What to do about handling "HandledRoute" type?
var contentfulRoutePlugin = function (route, conf) { return __awaiter(void 0, void 0, void 0, function () {
    var contentfulClientOptions, client, entries, e_1, details;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                contentfulClientOptions = {
                    space: conf.config.spaceId,
                    accessToken: conf.config.accessToken
                };
                client = createClient(contentfulClientOptions);
                return [4 /*yield*/, client.getEntries({
                        content_type: conf.config.contentType
                    })];
            case 1:
                entries = _a.sent();
                return [2 /*return*/, entries.map(function (e) { return (__assign({ route: "article/" + e.sys.id, type: 'contentful' }, e.fields)); })];
            case 2:
                e_1 = _a.sent();
                details = void 0;
                if (e_1.code === "ENOTFOUND") {
                    details = "You seem to be offline";
                }
                else if (e_1.code === "SELF_SIGNED_CERT_IN_CHAIN") {
                    console.error(
                    // tslint:disable-next-line:max-line-length
                    "We couldn't make a secure connection to your contentful space. Please check if you have any self-signed SSL certificates installed.");
                }
                else if (e_1.response) {
                    if (e_1.response.status === 404) {
                        // host and space used to generate url
                        details = "Endpoint not found. Check if\n          host\n        and spaceId settings are correct";
                    }
                    else if (e_1.response.status === 401) {
                        // authorization error
                        details = "Authorization error. Check if\n          accessToken\n        and environment are correct";
                    }
                }
                console.error("Accessing your Contentful space failed.\n    Try setting GATSBY_CONTENTFUL_OFFLINE=true to see if we can serve from cache.\n    " + (details ? "\n" + details + "\n" : ""));
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
var validator = function (conf) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
    return [2 /*return*/, []];
}); }); };
var ɵ0 = validator;
var Contentful = 'contentful';
registerPlugin('router', Contentful, contentfulRoutePlugin, validator);

/*
 * Public API Surface of scully-plugin-contentful
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Contentful };
//# sourceMappingURL=scully-plugin-contentful.js.map
